String dummy(String callNumber){
  
  String s = "";
  if (callNumber.equals("791.45028 N661N 2016")){
    s = "Trevor";
  }
  else if (callNumber.equals("CD 782.42166 N86")){
    s = "Compilation";
  }
  else if (callNumber.equals("CDJ 782.42083 K541")){
    s = "Kidz";
  }
  else if (callNumber.equals("797.12309 B8126B 2013")){
    s = "Brown"; 
  }
  else if (callNumber.equals("CD 782.42166 Ad32T")){
    s = "Adele";
  }
  return s;
}

void draw_points(float x_axis, float y_axis, float z_axis, color mycolor){
  pushMatrix(); 
  strokeWeight(5);
  stroke(mycolor);
  point(x_axis, y_axis, z_axis);  
  popMatrix(); 
  return;
}


float multiplyMatricesCell(float[][] firstMatrix, float[][] secondMatrix, int row, int col) {
    float cell = 0;
    for (int i = 0; i < secondMatrix.length; i++) {
        cell += firstMatrix[row][i] * secondMatrix[i][col];
    }
    return cell;
}

float [][] multiplyMatrices(float[][] firstMatrix, float[][] secondMatrix) {
    float[][] result = new float[firstMatrix.length][secondMatrix[0].length];

    for (int row = 0; row < result.length; row++) {
        for (int col = 0; col < result[row].length; col++) {
            result[row][col] = multiplyMatricesCell(firstMatrix, secondMatrix, row, col);
        }
    }

    return result;
}
/* 
https://www.baeldung.com/java-matrix-multiplication
*/ 

int dummy_num(String callNumber){
  
  int num = 0;
  if (callNumber.equals("791.45028 N661N 2016")){
    num = 5;
  }
  else if (callNumber.equals("CD 782.42166 N86")){
    num = 4;
  }
  else if (callNumber.equals("CDJ 782.42083 K541")){
    num = 3;
  }
  else if (callNumber.equals("797.12309 B8126B 2013")){
    num = 2; 
  }
  else if (callNumber.equals("CD 782.42166 Ad32T")){
    num = 1;
  }
  return num;
}


float[][][] createTese(){
  float[][] p1 = {{-1, -1, -1, 1}}; 
  float[][] p2 = {{1, -1, -1, 1}};
  float[][] p3 = {{1, 1, -1, 1}}; 
  float[][] p4 = {{-1, 1, -1, 1}};
  float[][] p5 = {{-1, -1, 1, 1}};
  float[][] p6 = {{1, -1, 1, 1}};
  float[][] p7 = {{1, 1, 1, 1}};
  float[][] p8 = {{-1, 1, 1, 1}};
  float[][] p9 = {{-1, -1, -1, -1}};
  float[][] p10 = {{1, -1, -1, -1}};
  float[][] p11 = {{1, 1, -1, -1}};
  float[][] p12 = {{-1, 1, -1, -1}};
  float[][] p13 = {{-1, -1, 1, -1}};
  float[][] p14 = {{1, -1, 1, -1}};
  float[][] p15 = {{1, 1, 1, -1}};
  float[][] p16 = {{-1, 1, 1, -1}};
  float[][][] tesseract = {p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16};
  
  return tesseract;
}


void connect_all(float[][][] projected_3d){
  for (int i = 0; i < 4; i++) {
    connect(0, i, (i + 1) % 4, projected_3d);
    connect(0, i + 4, ((i + 1) % 4) + 4, projected_3d);
    connect(0, i, i + 4, projected_3d);
  }


  for (int i = 0; i < 4; i++) {
    connect(8, i, (i + 1) % 4, projected_3d);
    connect(8, i + 4, ((i + 1) % 4) + 4, projected_3d);
    connect(8, i, i + 4, projected_3d);
  }

  for (int i = 0; i < 8; i++) {
    connect(0, i, i + 8, projected_3d);
  }
}


void connect(int offset, int i, int j, float[][][] projected_3d) {
  float[][] a = projected_3d[i + offset];
  float[][] b = projected_3d[j + offset];
  strokeWeight(4);
  stroke(255);
  line(a[0][0], a[0][1], a[0][2], b[0][0], b[0][1], b[0][2]);
}

void draw_tesseract(float[][][] rotation_matrices){
     float[][][] tesseract = createTese();
     for (int i = 0; i < tesseract.length; i++){

       int[] indices = {0,1}; 
       float[][] rotate_tese = rotate_it(tesseract[i], rotation_matrices, indices);
       float[][] proj_tese = project_it(rotate_tese);

       float tes_x = proj_tese[0][0];
       float tes_y = proj_tese[0][1];
       float tes_z = proj_tese[0][2];
       
       projected_3d[i][0][0] = tes_x*40;
       projected_3d[i][0][1] = tes_y*40;
       projected_3d[i][0][2] = tes_z*40;
       
            
       draw_points(tes_x*40, tes_y*40, tes_z*40, #ffa600); 
     }
     connect_all(projected_3d); 
}

float[][] rotate_it(float[][] original, float[][][] rotation_matrices, int[] indices){
    int idx1 = indices[0];
    int idx2 = indices[1];
    float[][] rotated = multiplyMatrices(original, rotation_matrices[idx1]);
    rotated = multiplyMatrices(rotated, rotation_matrices[idx2]);
    return rotated;
 }
 
 float[][] project_it(float[][] rotated){
     float proj_w = rotated[0][2];
     float distance = 2;
     float w = 1/ (distance - proj_w);
     
     float[][] proj_mat = {{w,0,0}, {0,w,0}, {0,0,w}, {0,0,0}};
     float[][] projected = multiplyMatrices(rotated, proj_mat);
     
     return projected;
 }
 
 void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}
